﻿var app = window.app = window.app || {};
app.vm = app.vm || {};


app.vm.Stat = function () {
    var self = this;
    self.datasets = ko.observableArray();
    self.datasetSumCountAccess = ko.observable();
    self.datasetSumCountDownload = ko.observable();
    self.sessionCounter = ko.observable();
    self.categories = ko.observableArray();
    self.departmentsCount = ko.observableArray();
    self.categoriesCount = ko.observableArray();
    self.foreign = ko.observable(false);
    self.filterDataset = ko.observableArray();
    self.filterDataset.subscribe(function () {
        if (self.pageNumber() != 1)
            self.pageNumber(1);
        else {
            self.loadDatasetsCounters();
        }

    });

    self.newDate = function (i, name) {
        var now = new Date();
        if (name != 'Month') {
            now.setDate(now.getDate() - i);
        } else {
            now.setMonth(now.getMonth() - i);
        }
        return now;
    };

    self.times = [
       { caption: 'За весь период', enCaption: 'All time', name: 'AllTime', date: '' },
       { caption: 'Вчера', enCaption: 'Yesterday', name: 'Yesterday', date: '(' + self.newDate(1, 'Yesterday').format('dd.mm.yyyy') + ')' },
       { caption: 'Сегодня', enCaption: 'Today', name: 'Today', date: '(' + self.newDate(0, 'Today').format('dd.mm.yyyy') + ')' },
       { caption: 'Неделя', enCaption: 'Week', name: 'Week', date: '(' + self.newDate(7, 'Week').format('dd.mm.yyyy') + ' - ' + self.newDate(0).format('dd.mm.yyyy') + ')' },
       { caption: 'Месяц', enCaption: 'Month', name: 'Month', date: '(' + self.newDate(1, 'Month').format('dd.mm.yyyy') + ' - ' + self.newDate(0).format('dd.mm.yyyy') + ')' },
       { caption: 'Период', enCaption: 'Period', name: 'Period', date: '' }
    ];
    self.time = ko.observable('Week');
    self.formatedStart = ko.observable();
    self.formatedEnd = ko.observable();
    //self.startP = ko.observable(today);
    //self.endP = ko.observable(today);

    self.startZ = ko.observable(new Date());
    self.startZ.subscribe(function () {
        console.log('дата изменена');
    });
    self.endZ = ko.observable(new Date());
    self.endZ.subscribe(function () {
        $.when(self.loadDatasetsCounters()).then(function () {
            $.when(self.loadDepartmentsCounters()).then(function () {
                self.loadCategoriesCounters();
            });
        });
    });

    self.start = ko.computed(function () {
        var today = new Date();
        today.setHours(0, 0, 0, 0);
        switch (self.time()) {
            case "AllTime":
                break;
            case "Yesterday":
                today.setDate(today.getDate() - 1);
                break;
            case "Today":
                break;
            case "Week":
                today.setDate(today.getDate() - 7);
                break;
            case "Month":
                today.setMonth(today.getMonth() - 1);
                break;
            case "Period":
                today = self.startZ();
                today.setHours(0, 0, 0, 0);
                break;
            default:
                break;
        }
        self.formatedStart(today.format("dd.mm.yyyy"));
        console.log(today);
        return today;
    });

    self.end = ko.computed(function () {
        var today = new Date();
        today.setHours(23, 59, 59, 59);
        self.formatedEnd(today.format("dd.mm.yyyy"));
        if (self.time() == 'Period') {
            today = self.endZ();
            today.setHours(23, 59, 59, 59);
        }
        return today;
    });
    var flag = false;
    self.start.subscribe(function () {
        flag = true;
        $.when(self.loadDatasetsCounters()).then(function () {
            $.when(self.loadDepartmentsCounters()).then(function () {
                self.loadCategoriesCounters();
            });
        });
        //self.loadCategoriesCounters();
        //self.loadDepartmentsCounters();
        //self.loadDatasetsCounters();
        flag = false;
    });
    //self.end.subscribe(function () {
    //    if (!flag) {
    //        self.loadCategoriesCounters();
    //        self.loadDepartmentsCounters();
    //        self.loadDatasetsCounters();
    //    }
    //});
    self.tabs = [
       { caption: 'Наборы данных', enCaption: 'Datasets', name: 'datasets' },
       { caption: 'ОИВ', enCaption: 'Departments', name: 'departments' },
       { caption: 'Категории', enCaption: 'Categories', name: 'categories' }
    ];
    self.tab = ko.observable('datasets');
    self.tab.subscribe(function () {
        switch (self.tab()) {
            case 'datasets':
                self.loadDatasetsCounters();
            case 'departments':
                self.departmentsCount().length == 0 ? self.loadDepartmentsCounters() : true;
            case 'categories':
                self.categoriesCount().length == 0 ? self.loadCategoriesCounters() : true;
            default:
                break;
        }
    });
    self.pageSizeList = ko.observableArray([5, 10, 20, 50, 100]);
    self.count = ko.observable();
    self.take = ko.observable(10);
    self.skip = ko.observable(0);
    self.pageSize = ko.observable(10);
    self.pageSize.subscribe(function () {
        if (self.pageNumber() != 1) {
            self.pageNumber(1);
        } else {
            self.loadDatasetsCounters();
        }
    });
    self.pageNumber = ko.observable(1);
    self.pageNumber.subscribe(function () {
        self.loadDatasetsCounters();
    });

    self.sortField = ko.observable('Access');
    self.sortOrder = ko.observable('DESC');
    self.sortOrder.subscribe(function () {
        switch (self.tab()) {
            case 'datasets':
                self.loadDatasetsCounters();
            case 'departments':
                self.loadDepartmentsCounters();
            case 'categories':
                self.loadCategoriesCounters();
            default:
                break;
        }
    });
    self.sortField.subscribe(function () {
        switch (self.tab()) {
            case 'datasets':
                self.loadDatasetsCounters();
            case 'departments':
                self.loadDepartmentsCounters();
            case 'categories':
                self.loadCategoriesCounters();
            default:
                break;
        }
    });

    self.loading = ko.observable(true);

    self.selectAll = function () {
        if (self.filterDataset().length == self.categories().length) {
            self.filterDataset.removeAll();
            self.datasets.removeAll();
            self.pageNumber(1);
        } else {
            self.filterDataset($.map(self.categories(), function (st) { return st.Id; }));
        }
    };

    self.toggleCategory = function (data) {
        if (self.filterDataset.indexOf(data) < 0) {
            self.filterDataset.push(data);
        } else {
            self.filterDataset.remove(data);
        }
        return true;
    };

    self.checkCategory = function (data) {
        return self.filterDataset.indexOf(data) >= 0;
    };


    self.toggleSorting = function (index) {
        if (self.sortField() === index) {
            if (self.sortOrder() === 'ASC') self.sortOrder('DESC');
            else self.sortOrder('ASC');
        } else {
            self.sortField(index);
        }
    };

    self.loadCategories = function () {
        return $.getJSON(app.root + "api/Categories/GetCategoriesDictionary?foreign=" + self.foreign(), function (result) {
            var arr = [];
            for (var category in result) {
                arr.push({ Id: category, Name: result[category] });
            }
            self.categories(arr);
            self.filterDataset($.map(arr, function (st) { return st.Id; }));
        });
    };

    self.getEndDate = function () {
        var end = new Date();
        end.setHours(23, 59, 59, 59);
        if (self.time() == 'Period') {
            end = self.endZ();
        }
        if (self.time() == 'Yesterday') {
            end.setDate(end.getDate() - 1);
        }
        return end;
    };

    self.loadCategoriesCounters = function () {
        var end = self.getEndDate();
        return $.ajax({
            type: 'GET',
            contentType: "application/json; charset=utf-8",
            url: app.root + "Api/Categories/GetCategoriesCounters/",
            data: { time: self.time(), startTime: self.start().format("mm/dd/yyyy HH:MM:ss"), endTime: end.format("mm/dd/yyyy HH:MM:ss"), sortField: self.sortField(), sortOrder: self.sortOrder(), foreign: self.foreign() },
            dataType: "json",
            success: function (results) {
                //console.log(results);
                self.categoriesCount(results);
            }
        });
    };

    self.loadDepartmentsCounters = function () {
        var end = self.getEndDate();
        return $.ajax({
            type: 'GET',
            contentType: "application/json; charset=utf-8",
            url: app.root + "Api/Departments/GetDepartmentsCounters/",
            data: { time: self.time(), startTime: self.start().format("mm/dd/yyyy HH:MM:ss"), endTime: end.format("mm/dd/yyyy HH:MM:ss"), sortField: self.sortField(), sortOrder: self.sortOrder(), foreign: self.foreign() },
            dataType: "json",
            success: function (results) {
                // console.log(results);
                self.departmentsCount(results);
            }
        });
    };

    self.loadDatasetsCounters = function () {
        self.skip((self.pageNumber() * self.pageSize()) - self.pageSize());
        self.loading(true);
        var end = self.getEndDate();
        return $.ajax({
            type: 'GET',
            contentType: "application/json; charset=utf-8",
            url: app.root + "Api/Datasets/GetDatasetsCounters/",
            data: { time: self.time(), startTime: self.start().format("mm/dd/yyyy HH:MM:ss"), endTime: end.format("mm/dd/yyyy HH:MM:ss"), sortField: self.sortField(), sortOrder: self.sortOrder(), filter: self.filterDataset(), skip: self.skip(), take: self.pageSize(), foreign: self.foreign() },
            dataType: "json",
            success: function (results) {
                //console.log(results);
                if (results.length != 0) {
                    self.count(results.Count);
                    self.datasetSumCountAccess(results.CountAccess);
                    self.datasetSumCountDownload(results.CountDownload);
                    self.datasets(results.Objects);
                    self.sessionCounter(results.CountSessions);
                } else {
                    self.count(0);
                    self.datasets.removeAll();
                }
                app.helpers.setPaging("#pager", self.pageNumber(), Math.ceil(self.count() / self.pageSize()), self.pageNumber);
                self.loading(false);
            }
        });
    };
};

app.stat = new app.vm.Stat();