﻿var app = window.app = window.app || {};
app.vm = app.vm || {};

ko.observableArray.fn.contains = function (item) {
    return this.indexOf(item) >= 0;
};

app.vm.dataset = function () {
    var self = this;

    self.id = ko.observable(0);

    self.viewMode = ko.observable('table');
    self.viewMode.subscribe(function (val) {

    });
    self.showingDiv = ko.observable('');

    self.pageNumber = ko.observable();
    self.pageSize = ko.observable(10);
    self.pageSize.subscribe(function () {
        self.pageNumber(1);
    });
    self.search = ko.observable("").extend({ throttle: 500 });
    self.search.subscribe(function () {
        self.pageNumber(1);
    });
    self.start = ko.computed(function () {
        return self.pageSize() * (self.pageNumber() - 1);
    });
    self.count = ko.observable(0);
    self.sortField = ko.observable(0);
    self.sortOrder = ko.observable('ASC');

    self.toggleSorting = function (index) {
        if (self.sortField() === index) {
            if (self.sortOrder() === 'ASC') self.sortOrder('DESC');
            else self.sortOrder('ASC');
        } else {
            self.sortField(index);
        }
    };

    self.caption = ko.observable("");
    self.columns = ko.observableArray();
    self.columns.subscribe(function () {
        mediator.broadcast("ColumnsLoaded", self.columns);
    });
    self.versionNumber = ko.observable(null);
    self.releaseNumber = ko.observable(1);
    self.versionId = ko.observable(null);
    self.columnsGroups = ko.observableArray();
    self.files = ko.observableArray();
    self.description = ko.observable("");
    self.publishDate = ko.observable();

    self.linkedDatasets = ko.observableArray();

    self.filters = [];
    self.bigFilter = ko.observable(null);
    self.bigFilter.subscribe(function () {
        self.pageNumber(1);
    });
    self.rows = ko.observableArray();

    self.allgroupsIds = ko.observableArray([]);
    self.groupids = ko.observableArray([]);

    mediator.add('app.Dataset', {
        onBigFilterLoaded: function (val) {
            self.bigFilter(val());
        }
    });
    var i = 0;
    self.addAutocomplite = function (element, data) {
        if (i != 0) {
            var id = "[id=autoHeadVal" + i + "]";
            $.each($(document.querySelectorAll(id)), function(j, item) {
                var col = data;
                var oldVal = data.filter();
                $(item).autocomplete({
                    minLength: 3,
                    source: function(request, response) {
                        $.ajax({
                            type: 'GET',
                            contentType: "application/json; charset=utf-8",
                            url: app.root + "Api/Filters/GetAllowValueByColumn/",
                            data: { datasetId: self.id(), versionNumber: self.versionNumber(), releaseNumber: self.releaseNumber(), columnName: col.Name, partStr: request.term },
                            dataType: "json",
                            success: function(results) {
                                response($.map(results, function(obj) {
                                    return {
                                        label: results[obj],
                                        value: [obj]
                                    };
                                }));
                            }
                        });
                    },
                    focus: function() {
                        return false;
                    },
                    select: function(event, ui) {
                        col.filter(ui.item.value[0]);
                        return true;
                    }
                });
                data.filter(oldVal);
            });
        }
        i++;
    };

    //self.addAutocompliteToHeadFilter = function (index) {
    //    var id = "[id=autoHeadVal" + index + "]";
    //    $.each($(document.querySelectorAll(id)), function (i, item) {
    //        var oldVal = self.columns()[index].filter();
    //        $(item).autocomplete({
    //            source: self.columns()[index].allowValue(),
    //            focus: function () {
    //                return false;
    //            },
    //            select: function (event, ui) {
    //                //var terms = split(this.value);
    //                //terms.pop();
    //                //terms.push(ui.item.value);
    //                //terms.push("");
    //                self.columns()[index].filter(ui.item.value);
    //                //this.value=ui.item.value;
    //                return false;
    //            }
    //        });
    //        self.columns()[index].filter(oldVal);
    //    });
    //};

    self.loading = ko.observable(false);
    ko.utils.extend(self.rows, {
        load: function () {
            if (self.viewMode() == 'table') {
                if (!isNaN(self.start()) && self.id() != 0) {
                    self.loading(true);
                    return $.getJSON(app.root + "api/rows/Get", { datasetId: self.id(), search: self.search(), filters: self.filters, sortField: self.sortField(), sortOrder: self.sortOrder(), start: self.start(), count: self.pageSize(), versionNumber: self.versionNumber(), releaseNumber: self.releaseNumber(), bigFilter: self.bigFilter() }, function (data) {
                        $.each(data.Result, function (i, item) {
                            ko.utils.extend(item, { showDetails: ko.observable(false), linkedDataView: ko.observable(0), linkedData: ko.observableArray(), loading: ko.observable(false) });
                        });
                        self.rows(data.Result);
                        self.count(data.Count);
                        self.loading(false);
                        app.helpers.setPaging("#pager", self.pageNumber(), Math.ceil(self.count() / self.pageSize()), self.pageNumber);
                        $(".data-container").scrollTop(0).scrollLeft(0);
                    });
                }
            }
            return true;
        }
    });

    self.displayMode = ko.observable(1);
    self.displayMode.subscribe(function (val) {
        $.each(self.columns(), function (i, item) {
            item.visible(item.DisplayMode >= val);
        });
    });
    self.showArrows = ko.observable(false);
    self.hiddenColumnsCount = ko.computed(function () {
        return self.columns().filter(function (item) { return !item.visible(); }).length;
    });
    self.visibleDetailsRowsCount = ko.computed(function () {
        return self.rows().filter(function (item) {
            return item.showDetails();
        });
    });
    ko.computed(function () {
        self.pageSize();
        self.rows.load();
        //debugger;
    });

    self.GetColumnsByGroup = function (groupId) {
        return $.map(self.columns(), function (col) { return col.GroupId == groupId && col.Name != "Number" ? col : null; });
    };

    self.GetGroupByParent = function (groupId) {
        return $.map(self.columnsGroups(), function (group) { return group.ParentId == groupId ? group : null; });
    };

    self.getLinkedColumns = function () {
        var res = [];
        $.each(self.columns(), function (i, col) {
            if (col.LinkedColumns) {
                for (var r = 0; r < col.LinkedColumns.length; r++) {
                    res.push(col.LinkedColumns[r]);
                }
            };
        });
        return res;
    };

    //self.loadAllowValueToHead = function (col, index) {
    //    return $.ajax({
    //        type: 'GET',
    //        contentType: "application/json; charset=utf-8",
    //        url: app.root + "Api/Filters/GetAllowValueByColumn/",
    //        data: { datasetId: self.id(), versionNumber: self.versionNumber(), releaseNumber: self.releaseNumber(), columnName: col.Name },
    //        dataType: "json",
    //        success: function (results) {
    //            // console.log(results);
    //            col.allowValue(results);
    //            self.addAutocompliteToHeadFilter(index);
    //        }
    //    });
    //};

    self.load = function (id, culture) {
        self.id(id);
        return $.getJSON(app.root + "api/datasets/Get/", { id: id, versionNumber: self.versionNumber() }, function (result) {
            self.caption(result.Caption);
            self.description(result.Description);
            self.versionId(result.VersionId);
            var allcol = [];
            var allVis = [];
            $.each(result.Columns, function (i, item) {
                ko.utils.extend(item, {
                    filter: ko.observable().extend({ throttle: 500 }),
                    visible: ko.observable(item.DisplayMode >= self.displayMode() && item.Caption.indexOf('Идентификатор') == -1),
                });
                item.filter.subscribe(function (val) {
                    self.filters[i] = val;
                    if (self.pageNumber() == 1) self.rows.load();
                    else self.pageNumber(1);
                });
                item.visible.subscribe(function() {
                    self.groupids.contains(item.Id)?self.groupids.remove(item.Id): self.groupids.push(item.Id);
                });
                if (item.Id != 0) {
                    if (item.visible()) allVis.push(item.Id);
                    allcol.push(item.Id);
                }
            });
            self.groupids(allVis);
            self.allgroupsIds(allcol);
            self.columns(result.Columns);
            self.filterColumn($.map(result.Columns, function (col) { return col.DefaultPosition; }));
            //self.addAutocompliteToHeadFilter();
            //self.rows.load();
        });
    };

    self.loadGroup = function () {
        return $.getJSON(app.root + "api/columns/GetColumnsGroup", { datasetVersionId: self.versionId() }, function (result) {
            var arr = [];
            for (var i = 0; i < result.length; i++) {
                result[i].ParentId = result[i].ParentId ? result[i].ParentId : null;
                arr.push(result[i]);
            }
            self.columnsGroups(arr);
            $.each(self.columnsGroups(), function (i, item) {
                ko.utils.extend(item, { visible: ko.observable(item.Visible), visNode: ko.observable(false) });
                item.visible.subscribe(function () {
                    self.toggleColumnVisible(item.Id, item.visible());
                });
                item.visNode.subscribe(function () {
                    self.toggleColumnVisibleNode(item.Id, item.visNode());
                });
            });
        });
    };

    self.loadFiles = function (id) {
        return $.getJSON(app.root + "api/documents/getrowsdocuments", { datasetId: id, versionId: self.versionId() }, function (result) {
            self.files(result);
        });
    };

    self.loadLinkedDatasets = function () {
        var links = self.getLinkedColumns();
        for (var i = 0; i < links.length; i++) {
            var link = links[i];
            $.getJSON(app.root + "api/datasets/GetByColumnId", { columnId: link.DestinationColumnId }).then(function (result) {
                result.linkId = link.Id;
                for (var i = 0; i < result.Groups.length; i++) {
                    result.Groups[i].Columns = result.Columns.Where("GroupId", result.Groups[i].Id);
                    result.Groups[i].Visible = ko.observable(result.Groups[i].Visible);
                }
                result.Columns = result.Columns.Where("GroupId", null);
                result.Groups = app.helpers.getTree(result.Groups, null);
                self.linkedDatasets.push(result);
            });
        }
    };

    self.toggleColumnVisible = function (id, visible) {
        $.map(self.GetColumnsByGroup(id), function (col) { return col.visible(visible); });
        var sp = self.GetGroupByParent(id);
        for (var i = 0; i < sp.length  ; i++) {
            sp[i].visible(visible);
            self.toggleColumnVisible(sp[i].Id, visible);
        }
        //$.map(self.GetGroupByParent(id), function (gr) { return gr.visible(visible); });
    };

    self.toggleColumnVisibleNode = function (id, visible) {
        if (!visible) {
            $.map(self.GetGroupByParent(id), function (gr) { return gr.visNode(visible); });
        }
    };

    /*для проведения группировок*/
    self.filterColumn = ko.observableArray();

    self.toggleColumn = function (data) {
        if (self.filterColumn.indexOf(data) < 0) {
            self.filterColumn.push(data);
            afterRender();
        } else {
            self.filterColumn.remove(data);
        }
        return true;
    };

    self.checkColumn = function (data) {
        return self.filterColumn.indexOf(data) >= 0;
    };

    self.getVisibleColums = function () {
        return ko.utils.arrayMap(self.columns(), function (col) { return col.visible() ? col : null; });
    };

    self.getLinkedDataForRow = function (linkId, indexRow) {
        if (linkId == 0)
            return null;
        var linkedDataset = self.linkedDatasets().first(function (d) { return d.linkId == linkId; });
        if (!linkedDataset)
            return null;

        var linkedData = self.rows()[indexRow].linkedData().first(function (d) { return d.linkId == linkId; });
        if (!linkedData) {
            self.rows()[indexRow].loading(true);
            var link = self.getLinkedColumns().first(function (val) { return val.Id == linkId; });
            var sourceCol = self.columns().first(function (val) { return val.Id == link.SourceColumnId; });
            var cellValue = self.rows()[indexRow].Cells[self.columns().indexOf(sourceCol) - 1];
            $.getJSON(app.root + "api/rows/GetByColumnValue", { columnId: link.DestinationColumnId, columnValue: cellValue }, function (data) {
                if (data.Result[0]) {
                    linkedData = { linkId: linkId, Cells: data.Result[0].Cells };
                    self.rows()[indexRow].linkedData.push(linkedData);
                } else {
                    self.rows()[indexRow].linkedData.push({ linkId: linkId, Cells: [] });
                }
            }).done(function () {
                self.rows()[indexRow].loading(false);
                return {
                    Cells: linkedData.Cells,
                    ChildGroups: linkedDataset.Groups,
                    Columns: linkedDataset.Columns,
                    Visible: true,
                    Name: ""
                };
            });
        } else {
            return {
                ChildGroups: linkedDataset.Groups,
                Cells: linkedData.Cells,
                Columns: linkedDataset.Columns,
                Visible: true,
                Name: ""
            };
        }
    };

    self.getValueColor = function (val) {
        var colors = {
            'green': ['полностью:completely', 'полностью', 'completely', 'есть:available', 'есть', 'available', 'соответствует:adequate', 'соответствует', 'adequate', 'доступно:accessible', 'доступно', 'accessible'],
            'orange': ['частично:partially', 'частично', 'partially'],
            'red': ['недоступно:inaccessible', 'недоступно', 'inaccessible', 'нет:unvailable', 'нет', 'unvailable', 'не соответствует:inadequate', 'не соответствует', 'inadequate']
        };
        for (var color in colors) {
            if (colors[color].indexOf(val) >= 0) return color;
        }
        return '';
    };

    self.chooseAll = function() {
        if (self.allgroupsIds().length == self.groupids().length) {
            $.map(self.columns(), function (col) { return col.Id!=0?col.visible(false): null; });
            self.groupids.removeAll();
        } else {
            $.map(self.columns(), function (col) { return col.Id!=0?col.visible(true):null; });
        }
    };

};

app.dataset = new app.vm.dataset;