﻿var app = window.app = window.app || {};
app.vm = app.vm || {};

function FilterObj() {
    var it = this;
    it.Column = ko.observable();
    it.Operation = ko.observable();
    it.AllowValue = ko.observableArray();
    it.Value = ko.observableArray();
    it.Operation.subscribe(function () {
        console.log("Вызов запроса");
        app.filterDataset.executeFilter();
    });
    it.Value.subscribe(function () {
        console.log("Вызов запроса");
        app.filterDataset.executeFilter();
    });
};

function ValueInArray(value) {
    var val = this;
    val.val = ko.observable(value);
    val.val.subscribe(function() {
        console.log("Значение изменилось");
        app.filterDataset.executeFilter();
    });
}

app.vm.filterDataset = function () {
	var self = this;
    self.datasetId = ko.observable();
    self.releaseNumber = ko.observable();
    self.versionNumber = ko.observable(null);
    self.activeMenuColumn = ko.observable(null);
    self.activeMenuOperation = ko.observable(null);
    self.lastFiltration = false;
    self.filterArray = ko.observableArray([]);
    //self.filterArray.subscribe(function () {
    //    console.log("Вызов запроса");
    //});
    self.allowColumns = ko.observableArray();
    self.allowOperation = ko.observableArray([
        { Name: "eq", Caption: "равно..." },
        { Name: "notEq", Caption: " не равно..." },
        { Name: "contains", Caption: "содержит..." },
        { Name: "notContains", Caption: "не содержит..." },
        { Name: "startWith", Caption: "начинается с..." }
    ]);

    mediator.add('app.filterDataset', {
        onColumnsLoaded: function (val) {
            self.allowColumns(val());
        }
    });



    self.addFilter = function () {
        var newFilter = new FilterObj();
        (self.filterArray().length < self.allowColumns().length-1)?
            newFilter.Column({ Name: self.allowColumns()[self.filterArray().length + 1].Name, Caption: self.allowColumns()[self.filterArray().length + 1].Caption })
            :newFilter.Column({ Name: self.allowColumns()[1].Name, Caption: self.allowColumns()[1].Caption });
            newFilter.Operation(self.allowOperation()[0]);
            newFilter.Value([new ValueInArray("")]);
        $.when(self.loadAllowValue(newFilter)).then(function() {
            self.filterArray.push(ko.observable(newFilter));
            self.addAutocomplite(self.filterArray().length - 1);
        });
    };

    self.addAutocomplite = function(index) {
        var id = "[id=autoVal" + index + "]";
        $.each($(document.querySelectorAll(id)), function (i, item) {
            $(item).autocomplete({
                source: self.filterArray()[index]().AllowValue(),
                focus: function () {
                    return false;
                },
                select: function (event, ui) {
                    //var terms = split(this.value);
                    //terms.pop();
                    //terms.push(ui.item.value);
                    //terms.push("");
                    self.filterArray()[index]().Value()[i].val(ui.item.value);
                    //this.value=ui.item.value;
                    return false;
                }
            });
        });
    };

    self.addNewValue = function(index) {
        self.filterArray()[index]().Value.push(new ValueInArray(""));
        self.addAutocomplite(index);
    };

    self.changeColumn = function(data) {
        //console.log(data);
        self.filterArray()[self.activeMenuColumn()]().Column({ Name: data.Name, Caption: data.Caption });
        self.filterArray()[self.activeMenuColumn()]().Value([new ValueInArray("")]);
        $.when(self.loadAllowValue(self.filterArray()[self.activeMenuColumn()]())).then(function () {
            self.addAutocomplite(self.activeMenuColumn());
            self.activeMenuColumn(null);
        });
    };

    self.openColumnList = function (index) {
        self.activeMenuColumn() != index ? self.activeMenuColumn(index) : self.activeMenuColumn(null);
        self.activeMenuOperation(null);
    };

    self.changeOperation = function (data) {
        //console.log(data);
        self.filterArray()[self.activeMenuOperation()]().Operation(data);
        self.activeMenuOperation(null);
    };

    self.openOperationList = function (index) {
        self.activeMenuOperation() != index ? self.activeMenuOperation(index) : self.activeMenuOperation(null);
    };

    self.deleteFilter = function (val) {
        self.filterArray.remove(val);
    };

    self.loadAllowValue = function (filter) {
        return $.ajax({
            type: 'GET',
            contentType: "application/json; charset=utf-8",
            url: app.root + "Api/Filters/GetAllowValueByColumn/",
            data: { datasetId: self.datasetId(), versionNumber: self.versionNumber(), releaseNumber: self.releaseNumber(), columnName: filter.Column().Name },
            dataType: "json",
            success: function (results) {
                // console.log(results);
                filter.AllowValue(results);
            }
        });
    };

    self.executeFilter = function () {
        var bigFilter = self.getItemForSend();
        if (bigFilter.length != 0|| self.lastFiltration==true) {
            self.lastFiltration = bigFilter.length == 0 ? false : true;
            mediator.broadcast("BigFilterLoaded", ko.observable(bigFilter.length == 0 ?null: bigFilter));
        }
        
    };

    self.getItemForSend = function() {
        var res = [];
        for (var i = 0; i < self.filterArray().length; i++) {
            var value = $.map(self.filterArray()[i]().Value(), function (val) { return val.val() != "" && val.val() != null ? val.val() : null; });
            if (value.length != 0) {
                res.push({
                    Column: self.filterArray()[i]().Column().Name,
                    Operation: self.filterArray()[i]().Operation().Name,
                    Values: value
                });
            }
        }
        return res;
    };

};
app.filterDataset = new app.vm.filterDataset;