﻿var app = window.app = window.app || {};
app.helpers = app.helpers || {};


app.helpers.initValues = function (self, obj) {
    if (obj) {
        for (var prop in obj) {
            var tmp = self[prop];
            // console.log(prop + ":" + tmp);
            if (tmp && ko.isWriteableObservable(tmp)) {
                var d = tmp.initValue || obj[prop];
                tmp(tmp.initValue || obj[prop]);
            } else {
                self[prop] = obj[prop];
            }
        }
    }
};

app.helpers.setPaging = function (el, page, count, onClick) {
    var maxCount = 4,
        start = 1,
        items = [];
    $(el).html("");
    if (page - 1 > count || count == 1) return;
    if (page + 2 > maxCount && page - 1 <= count) {
    	items.push("<button class='btn dml_10' onclick='void(0);'>&lt;&lt;</button>");
    	items.push("<button class='btn dml_10' onclick='void(0);'>&lt;</button>");
        start = page - 2;
        maxCount += page - 2;
    }

    for (var i = start, l = (count > maxCount ? maxCount : count) ; i <= l; i++) {
        if (i == page) {
        	items.push("<button class='btn active'><span>" + i + "</span></button>");
        } else {
        	items.push("<button class='btn' onclick='void(0);'>" + i + "</button>");
        }
    }
    if (count > maxCount) {
    	items.push("<button class='btn dml_10' onclick='void(0);'>&gt;</button>");
    	items.push("<button class='btn dml_10' onclick='void(0);'>&gt;&gt;</button>");
    }
    $(el).html(items.join(""));
    $('button').click(function (e) {
        e.preventDefault();
        
        var text = $(this).html(),
            p = page;
        switch (text) {
            case "&gt;":
                p = p + 1 < count ? p + 1 : count;
                break;
            case "&gt;&gt;":
                p = count;
                break;
            case "&lt;":
                p = p - 1 > 1 ? p - 1 : 1;
                break;
            case "&lt;&lt;":
                p = 1;
                break;
            default:
                p = parseInt(text);
                break;
        }
        app.helpers.setPaging(el, p, count, onClick);
        onClick && onClick(p);
        return false;
    });
};
app.helpers.getTree = function (source, val) {
    var tree = source.Where(function (item) {
        return item.ParentId == val;
    });
    for (var i = 0, l = tree.length; i < l; i++) {
        tree[i].Childrens = app.helpers.getTree(source, tree[i].Id);
    }
    return tree;
};
app.helpers.childefy = function (arr, id) {
    var res = [];
    id = id || null;
    for (var i = 0, l = arr.length; i < l; i++) {
        var r = arr.Where(function (item) { return item.ParentId === arr[i].Id; });
        if (r.length) {
            arr[i].Childrens = r;
        }
        arr[i].ParentId == id && res.push(arr[i]);
    }
    return res.length ? res : arr;
};