/*
	Author: Grachev Evgeniy
	E-mail: grachev.e@prognoz.ru
	E-mail: linless@rocketmail.com
*/

/*
	Комбобокс с универсальным функционалом


	Настройки:

	select : 'single'  ||   'multi'   ||   'checkbox'   ||   'radio'    ||   'other'

	arrowDisabled : true   - убирает стрелку у комбобокса

	selectClearText : '...'    -  текст, когда ничего не выбрано
	multiSelectText : '...'    - текст для множественной выборки
	closingWhenClick : true    - закрытие комбобокса при выборе элемента

	selectCheckboxAll : true   - добавляет кнопку "Выбрать все"
	selectCheckboxAllText : '...'    - Изменяет текст кнопки "Выбрать все"
	unselectCheckboxAll : true   - добавляет кнопки "Сбросить все"
	unselectCheckboxAllText : '...'  - Изменяет текст кнопки "Сбросить все"
	checkboxAllPosConversely : true  - Зеркально меняет кнопки "Выбрать все" и "Сбросить все"

	search : true   - включает поиск
	searchVisCount : 10    - если контента меньше, то поиск не появится
	searchNoResult : '...'  - текст если поиск ничего не нашел


*/


// Закрытие каждого комбобокса
function linEachBoxClosed() {
	$('.linbox').each( function () {

		if ( $(this).hasClass('linbox-open') ) {

			$(this).removeClass('linbox-open');

		}

	});
}

// Генератор рандомного айдишника
function generatorRandomId() {

	getStr = function(s){
		return s.charAt(Math.floor(Math.random() * s.length));
	}

	var s = '';
	iMax = 2 + Math.floor(Math.random() *4);
	for(i=0; i < iMax; i++)
	s += getStr('abcdefghijklmnopqrstuvwxyz');
	for(i=0; i <= 5; i++)
	s += getStr('0123456789');

	return s;


}

jQuery.fn.linbox = function( options )
{

	// Закрытие комбобокса при клике хоть куды
	$(document).on('click', function (e) {

		if( $(e.target).closest(".linbox").length ) return;

		linEachBoxClosed();

      	e.stopPropagation();

	});

	// Создание комбобокса с проверкой параметров
	$(this).each( function () {

		var _this = $(this),
			thisHtml = _this.html();

			_this.addClass('linbox');


		if ( !_this.attr('id') ) {

			var pincode = generatorRandomId();

			pincode = 'linbox-' + pincode;

			$('.linbox').each( function (){

				if ( $(this).attr('id') == pincode ) {

					pincode = generatorRandomId();
					pincode = 'linbox-' + pincode;
					
				}

			});

		} else {

			var pincode = _this.attr('id');

		}

		_this.html("");

		_this.append('<div class="linbox-header"><div class="linbox-header-text"></div></div>');

		if ( !options.arrowDisabled ) {

			_this.find('.linbox-header').append('<div class="linbox-header-arrow"></div>');

		}

		_this.append('<div class="linbox-content"></div>');
		_this.find('.linbox-content').html(thisHtml);

		if ( options.select != 'other' ) {

			_this.find('.linbox-content div').each( function () {

				var _this = $(this);

				_this.addClass('linbox-select');

				if ( _this.hasClass('disabled') ) {

					_this.removeClass('disabled').addClass('linbox-select-disabled');

				}

				if ( options.select == 'checkbox' ) {
					
					var thisHtml = _this.html();

					_this.html('');
					_this.append('<div class="linbox-select-checkbox-block"><div class="linbox-checkbox-image"></div><div class="linbox-checkbox-text"></div></div>');
					_this.find('.linbox-checkbox-text').html(thisHtml);


				}

				if ( options.select == 'radio' ) {
					
					var thisHtml = _this.html();

					_this.html('');
					_this.append('<div class="linbox-select-radio-block"><div class="linbox-radio-image"></div><div class="linbox-radio-text"></div></div>');
					_this.find('.linbox-radio-text').html(thisHtml);


				}

			});

		}

		if ( (options.select == 'checkbox') && (options.selectCheckboxAll) || (options.unselectCheckboxAll) ) {

			_this.find('.linbox-content').prepend('<div class="linbox-checkbox-options"><div></div><div></div></div>');

			if ( options.selectCheckboxAll ) {

				if ( options.checkboxAllPosConversely ) {

					_this.find('.linbox-checkbox-options div').eq(1).append('<span class="linbox-checked-all">Выбрать все</span>');

				} else {

					_this.find('.linbox-checkbox-options div').eq(0).append('<span class="linbox-checked-all">Выбрать все</span>');

				}


				if ( options.selectCheckboxAllText ) {

					_this.find('.linbox-checked-all').html(options.selectCheckboxAllText);

				}

			}

			if ( options.unselectCheckboxAll ) {

				if ( options.checkboxAllPosConversely ) {

					_this.find('.linbox-checkbox-options div').eq(0).append('<span class="linbox-unchecked-all">Отменить все</span>');

				} else {

					_this.find('.linbox-checkbox-options div').eq(1).append('<span class="linbox-unchecked-all">Отменить все</span>');

				}

				

				if ( options.unselectCheckboxAllText ) {

					_this.find('.linbox-unchecked-all').html(options.unselectCheckboxAllText);

				}

			}

		}

		if ( options.search ) {


			_this.find('.linbox-content').prepend('<div class="linbox-search-block"><input type="text" class="linbox-search" /></div>');
			_this.find('.linbox-content').append('<div class="linbox-search-result">ничего не найдено</div>');

			if ( options.searchVisCount ) {
					
				if ( _this.find('.linbox-select').length < options.searchVisCount ) {

					_this.find('.linbox-search-block').hide();

				}

			}

			if ( options.searchNoResult ) {

				_this.find('.linbox-search-result').html(options.searchNoResult);

			}

		}

		_this.attr('id',pincode);

		if ( options.selectClearText ) {

			_this.find('.linbox-header-text').html(options.selectClearText);

		} else {

			_this.find('.linbox-header-text').html('Выберите из списка');
			
		}

		$('<input type="hidden" class="linbox-hidden" id="' + pincode + '-input" />').insertBefore(_this);

		if ( _this.attr('name') ) {

			$('input#' + pincode + '-input').attr('name', _this.attr('name') );

		}

		if ( options.select == 'single' ) {

			_this.addClass('linbox-only-select');

		}

		if ( options.select == 'multi' ) {

			_this.addClass('linbox-multi-select');

		}


		// клик по бошке
		_this.find('.linbox-header').on( 'click', function (e) {

			var _this = $(this),
				parent = _this.closest('.linbox');

			if ( parent.hasClass('linbox-open') ) {

				parent.removeClass('linbox-open');

			} else {

				linEachBoxClosed();

				parent.addClass('linbox-open');

			}

			if ( options.search ) {

				parent.find('.linbox-search').val('');
				parent.find('.linbox-select').each( function () {

					$(this).removeClass('linbox-select-hide');

				});

				parent.find('.linbox-search-result').hide();

			}

		});


		// Нажатие по селекту
		_this.find('.linbox-select').on( 'click', function (e) {

			var _this = $(this),
				parent = _this.closest('.linbox'),
				parentId = parent.attr('id');

			var hiddenHtml = '';

			if ( !_this.hasClass('linbox-select-disabled') ) {

				// Single select
				if ( (options.select == 'single') || (options.select == 'radio') ) {

						parent.find('.linbox-header-text').html(_this.html());
						parent.find('.linbox-select').each( function () {

							$(this).removeClass('linbox-select-active');

						});

						_this.addClass('linbox-select-active');

						if ( options.select == 'single' ) {

							if ( options.closingWhenClick ) {

								parent.removeClass('linbox-open');

							}

							hiddenHtml = _this.html();
							
						}

						if ( options.select == 'radio' ) {

							if ( options.closingWhenClick ) {

								parent.removeClass('linbox-open');

							}

							hiddenHtml = $(this).find('.linbox-radio-text').html();

						}


				}

				// Multi select
				if ( (options.select == 'multi') || (options.select == 'checkbox') ) {

					if ( _this.hasClass('linbox-select-active') ) {

						_this.removeClass('linbox-select-active');

					} else {

						_this.addClass('linbox-select-active');

					}

					var countActiveSelect = parent.find('.linbox-select-active').length;

					if ( countActiveSelect == 0 ) {

						if ( options.selectClearText ) {

							parent.find('.linbox-header-text').html(options.selectClearText);

						} else {

							parent.find('.linbox-header-text').html('Выберите из списка');
							
						}

					} else {

						if ( options.multiSelectText ) {

							parent.find('.linbox-header-text').html(options.multiSelectText + ' ' + countActiveSelect);

						} else {

							parent.find('.linbox-header-text').html('Выбрано объектов: ' + countActiveSelect);
							
						}

					}

				}

				// Multi select вывод в инпут
				if ( parent.hasClass('linbox-multi-select') ) {

					hiddenHtml = '';

					// Заносит в переменную все выбранные значения
					parent.find('.linbox-select-active').each( function () {

						hiddenHtml += $(this).html() + ',';

					});

					hiddenHtml = hiddenHtml.slice(0, -1);

				}

				// Checkbox select вывод в инпут
				if ( options.select == 'checkbox' ) {

					hiddenHtml = '';

					// Заносит в переменную все выбранные значения
					parent.find('.linbox-select-active').each( function () {

						var _thisHtml = $(this).find('.linbox-checkbox-text').html();

						hiddenHtml += _thisHtml + ',';

					});

					hiddenHtml = hiddenHtml.slice(0, -1);

				}

				$('input#' + parentId + '-input').val(hiddenHtml);

			}

		});


		// Кнопка выбрать все чекбоксы
		_this.find('.linbox-checked-all').on( 'click', function (e) {

			var _this = $(this),
				parent = _this.closest('.linbox'),
				parentId = parent.attr('id');


			parent.find('.linbox-select').each( function () {

				var _this = $(this);

				if ( !_this.hasClass('linbox-select-disabled') && !_this.hasClass('linbox-select-hide') ) {

					if ( !_this.hasClass('linbox-select-active') ) {

						_this.addClass('linbox-select-active');

					}

				}

			});

			var countActiveSelect = parent.find('.linbox-select-active').length;

			if ( countActiveSelect == 0 ) {

				if ( options.selectClearText ) {

					parent.find('.linbox-header-text').html(options.selectClearText);

				} else {

					parent.find('.linbox-header-text').html('Выберите из списка');
					
				}

			} else {

				if ( options.multiSelectText ) {

					parent.find('.linbox-header-text').html(options.multiSelectText + ' ' + countActiveSelect);

				} else {

					parent.find('.linbox-header-text').html('Выбрано объектов: ' + countActiveSelect);
					
				}

			}


			hiddenHtml = '';

			// Заносит в переменную все выбранные значения
			parent.find('.linbox-select-active').each( function () {

				var _thisHtml = $(this).find('.linbox-checkbox-text').html();

				hiddenHtml += _thisHtml + ',';

			});

			hiddenHtml = hiddenHtml.slice(0, -1);


			$('input#' + parentId + '-input').val(hiddenHtml);


		});

		//Кнопка снять все чекбоксы
		_this.find('.linbox-unchecked-all').on( 'click', function (e) {

			var _this = $(this),
				parent = _this.closest('.linbox'),
				parentId = parent.attr('id');


			parent.find('.linbox-select').each( function () {

				var _this = $(this);

				_this.removeClass('linbox-select-active');

			});

			if ( options.selectClearText ) {

				parent.find('.linbox-header-text').html(options.selectClearText);

			} else {

				parent.find('.linbox-header-text').html('Выберите из списка');
				
			}

			hiddenHtml = '';

			// Заносит в переменную все выбранные значения
			parent.find('.linbox-select-active').each( function () {

				var _thisHtml = $(this).find('.linbox-checkbox-text').html();

				hiddenHtml += _thisHtml + ',';

			});

			hiddenHtml = hiddenHtml.slice(0, -1);


			$('input#' + parentId + '-input').val(hiddenHtml);

		});


		// Поиск
		_this.find('.linbox-search').keyup(function () {

			var _this = $(this),
				parent = _this.closest('.linbox'),
				searchText = _this.val();

			searchText = searchText.toLowerCase();

			parent.find('.linbox-select').each( function () {

				var thisHtml = $(this).html().toLowerCase();

				if ( options.select == 'checkbox' ) {

					var thisHtml = $(this).find('.linbox-checkbox-text').html().toLowerCase();

				}

				if ( options.select == 'radio' ) {

					var thisHtml = $(this).find('.linbox-radio-text').html().toLowerCase();

				}

				thisHtml = thisHtml.split(' ');

				var booleanSearch = 0;


				for ( var i = 0; i < thisHtml.length; i++ ) {

					if ( (thisHtml[i].indexOf(searchText, 0) + 1) == 1 ) {
						
						booleanSearch++;

					}
					
				};

				if ( booleanSearch > 0 ) {

					$(this).removeClass('linbox-select-hide');

				} else {

					$(this).addClass('linbox-select-hide');

				}


			});


			if ( parent.find('.linbox-select-hide').length == parent.find('.linbox-select').length ) {

				parent.find('.linbox-search-result').show();

			} else {

				parent.find('.linbox-search-result').hide();

			}







		});

		



	});

}